"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fsExtra = require("fs-extra");
var nodeSsh = require("node-ssh");
var os = require("os");
var path = require("path");
var shelljs = require("shelljs");
var audiodevice_1 = require("../utils/audiodevice");
var config_1 = require("../utils/config");
var snipsRSAKeyName = 'id_rsa_snips';
var snipsRSAKeyFilePath = os.homedir() + '/.ssh/' + snipsRSAKeyName;
var SSHService = (function () {
    function SSHService() {
        var _this = this;
        this.connect = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var credentials;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, config_1.Config.getCredentials()
                            .catch(function (error) {
                            throw new Error('No credentials found, reason: ' + error.message);
                        })];
                    case 1:
                        credentials = _a.sent();
                        if (credentials === undefined) {
                            throw new Error('No credentials found.');
                        }
                        return [2, this.connectInternal(credentials)
                                .catch(function (error) {
                                _this.disconnect();
                                throw new Error('Error connecting to your device, reason: ' + error.message);
                            })];
                }
            });
        }); };
        this.newConnection = function (credentials, password, onConnected, onSSHCopyId, onCredentialsSaved) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.connectInternal(credentials, password)
                            .then(function (success) { return onConnected(); })
                            .catch(function (e) {
                            throw new Error('Failed to connect to your device, reason: ' + e.message);
                        })];
                    case 1:
                        _a.sent();
                        return [4, this.sshCopyId(credentials.hostname, credentials.username)
                                .then(function (s) { return onSSHCopyId(); })
                                .catch(function (e) {
                                _this.disconnect();
                                throw new Error('Failed to copy your SSH public key, reason: ' + e.message);
                            })];
                    case 2:
                        _a.sent();
                        return [4, config_1.Config.saveCredentialsOnDisk(credentials)
                                .then(function (s) { return onCredentialsSaved(); })
                                .catch(function (e) {
                                _this.disconnect();
                                throw new Error('Failed to save credentials: ' + e.message);
                            })];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        }); };
        this.connectInternal = function (credentials, password) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.credentials = credentials;
                if (password != null) {
                    return [2, this.ssh.connect({
                            password: password,
                            host: this.credentials.hostname,
                            username: this.credentials.username,
                        })];
                }
                return [2, this.ssh.connect({
                        host: this.credentials.hostname,
                        username: this.credentials.username,
                        privateKey: snipsRSAKeyFilePath,
                    })];
            });
        }); };
        this.disconnect = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.ssh.dispose()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        }); };
        this.isAssistantInstalled = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("if [ -d /usr/share/snips/assistant ]; then echo 'true'; else echo 'false'; fi")
                        .then(function (success) {
                        return success === 'true' ? true : false;
                    })];
            });
        }); };
        this.getOSVersion = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('cat /etc/os-release')
                        .then(function (success) {
                        var osVersion = success.split('\n')[0].replace('PRETTY_NAME="', '').replace('"', '');
                        if (osVersion === null || osVersion.length === 0) {
                            return 'Unknown';
                        }
                        return osVersion;
                    })
                        .catch(function (err) {
                        return 'Unknown';
                    })];
            });
        }); };
        this.installSnipsPlatformDemo = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo apt-get install -y snips-platform-demo", listener)];
            });
        }); };
        this.speakerTest = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("speaker-test -c2 -l2 -twav")];
            });
        }); };
        this.getCaptureLevel = function (card) {
            if (card === void 0) { card = 1; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cget name='Mic Capture Volume'")];
                });
            });
        };
        this.setCaptureLevel = function (card, level) {
            if (card === void 0) { card = 1; }
            if (level === void 0) { level = 80; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cset name='Mic Capture Volume' " + level + "%")];
                });
            });
        };
        this.getVolumeLevel = function (card) {
            if (card === void 0) { card = 0; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cget name='PCM Playback Volume'")];
                });
            });
        };
        this.setVolumeLevel = function (card, level) {
            if (card === void 0) { card = 0; }
            if (level === void 0) { level = 90; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cset name='PCM Playback Volume' " + level + "%")];
                });
            });
        };
        this.recordAudio = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("arecord -f cd " + name + ".wav")];
            });
        }); };
        this.stopRecording = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("pkill arecord")];
            });
        }); };
        this.listCaptureDevices = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("arecord -l | grep -E '^[^  ][^**]'")
                        .then(function (success) {
                        var devices = String(success).split('\n');
                        if (devices.length === 0) {
                            throw new Error('No capture devices found. Check if your mic is correctly plugged.');
                        }
                        try {
                            return devices.map(function (device) { return new audiodevice_1.AudioDevice(device); });
                        }
                        catch (e) {
                            throw new Error('Error reading the information of the audio device: ' + e.message);
                        }
                    })];
            });
        }); };
        this.listOuputDevices = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("aplay -l | grep -E '^[^  ][^**]'")
                        .then(function (success) {
                        var devices = String(success).split('\n');
                        if (devices.length === 0) {
                            throw new Error('No output devices found. This should not happen, on your device, run \narecord -l');
                        }
                        try {
                            return devices.map(function (device) { return new audiodevice_1.AudioDevice(device); });
                        }
                        catch (e) {
                            throw new Error('Error reading the information of the audio device: ' + e.message);
                        }
                    })];
            });
        }); };
        this.launchSnipsWatch = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("snips-watch -v", listener)];
            });
        }); };
        this.journalctlLogs = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("watch journalctl -f -u \"snips*\"", listener)];
            });
        }); };
        this.snipsServicesSystemctlStatus = function () { return __awaiter(_this, void 0, void 0, function () {
            var hotword, queries, analytics, dialogue, asr, tts, audioServer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.ssh.exec("systemctl is-active snips-hotword.service >/dev/null 2>&1 && echo YES || echo NO")
                            .then(function (success) {
                            return success === 'YES' ? true : false;
                        })];
                    case 1:
                        hotword = _a.sent();
                        return [4, this.ssh.exec("systemctl is-active snips-queries.service >/dev/null 2>&1 && echo YES || echo NO")
                                .then(function (success) {
                                return success === 'YES' ? true : false;
                            })];
                    case 2:
                        queries = _a.sent();
                        return [4, this.ssh.exec("systemctl is-active snips-analytics.service >/dev/null 2>&1 && echo YES || echo NO")
                                .then(function (success) {
                                return success === 'YES' ? true : false;
                            })];
                    case 3:
                        analytics = _a.sent();
                        return [4, this.ssh.exec("systemctl is-active snips-dialogue.service >/dev/null 2>&1 && echo YES || echo NO")
                                .then(function (success) {
                                return success === 'YES' ? true : false;
                            })];
                    case 4:
                        dialogue = _a.sent();
                        return [4, this.ssh.exec("systemctl is-active snips-asr.service >/dev/null 2>&1 && echo YES || echo NO")
                                .then(function (success) {
                                return success === 'YES' ? true : false;
                            })];
                    case 5:
                        asr = _a.sent();
                        return [4, this.ssh.exec("systemctl is-active snips-tts.service >/dev/null 2>&1 && echo YES || echo NO")
                                .then(function (success) {
                                return success === 'YES' ? true : false;
                            })];
                    case 6:
                        tts = _a.sent();
                        return [4, this.ssh.exec("systemctl is-active snips-audio-server.service >/dev/null 2>&1 && echo YES || echo NO")
                                .then(function (success) {
                                return success === 'YES' ? true : false;
                            })];
                    case 7:
                        audioServer = _a.sent();
                        return [2, [
                                { name: 'snips-hotword', active: hotword },
                                { name: 'snips-queries', active: queries },
                                { name: 'snips-analytics', active: analytics },
                                { name: 'snips-dialogue', active: dialogue },
                                { name: 'snips-asr', active: asr },
                                { name: 'snips-tts', active: tts },
                                { name: 'snips-audio-server', active: audioServer },
                            ]];
                }
            });
        }); };
        this.playAudio = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("aplay " + name + ".wav").catch(function (e) { })];
            });
        }); };
        this.removeAudioFile = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("rm " + name + ".wav")];
            });
        }); };
        this.setupAsoundConf = function (outputDevice, captureDevice) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("(echo 'pcm.!default {';         echo '  type asym';         echo '  playback.pcm {';         echo '    type plug';         echo '    slave.pcm \"hw:" + outputDevice.card + "," + outputDevice.subdevice + "\"';         echo '  }';         echo '  capture.pcm {';         echo '    type plug';         echo '    slave.pcm \"dsnoop:" + captureDevice.card + "," + captureDevice.subdevice + "\"';         echo '  }';         echo '}')         | sudo tee /etc/asound.conf > /dev/null")];
            });
        }); };
        this.copySnipsFile = function (snipsfile) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("echo \"" + snipsfile + "\" | sudo tee ~/Snipsfile > /dev/null")];
            });
        }); };
        this.runSnipsmanagerInstall = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo snipsmanager install", listener)];
            });
        }); };
        this.installSnips = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                listener('Updating your device aptitude repository');
                return [2, this.sshCommandLog('sudo apt-get update', listener)
                        .then(function (success) {
                        return _this.sshCommandLog('sudo apt-get install -y dirmngr', listener)
                            .catch(function (err) { throw new Error("Couldn't install dirmngr"); });
                    })
                        .then(function (success) {
                        return _this.sshCommandLog("sudo bash -c 'echo \"deb https://raspbian.snips.ai/$(lsb_release -cs) stable main\" > /etc/apt/sources.list.d/snips.list'", listener)
                            .catch(function (err) { throw new Error("Couldn't update Snips apt sources on the device"); });
                    })
                        .then(function (success) {
                        var addSnipsKeyCommand = '';
                        try {
                            var snipsPGPPubKey = fsExtra.readFileSync(__dirname + '/snips-pgp-key.asc', 'utf8');
                            addSnipsKeyCommand = "(echo \"" + snipsPGPPubKey + "\" > ~/snips-pgp-key.asc) && sudo apt-key add ~/snips-pgp-key.asc && rm snips-pgp-key.asc";
                        }
                        catch (e) {
                            addSnipsKeyCommand = "sudo apt-key adv --keyserver pgp.mit.edu --recv-keys D4F50CDCA10A2849";
                        }
                        return _this.ssh.exec(addSnipsKeyCommand)
                            .catch(function (err) {
                            if (err.message.includes("gpg: key D4F50CDCA10A2849: \"Snips Raspbian distribution <infra@snips.ai>\" not changed") ||
                                err.message.includes("Warning: apt-key output should not be parsed (stdout is not a terminal)")) {
                                return;
                            }
                            throw new Error("Couldn't fetch the PGP certificate to authenticate Snips APT repository.\nTry again and if the problem persists, please contact us");
                        });
                    })
                        .then(function (success) {
                        listener('Installing Snips Platform');
                        return _this.sshCommandLog("sudo apt-get update && sudo apt-get install -y snips-platform-voice snips-watch snipsmanager", listener)
                            .catch(function (err) { throw new Error("There was a problem during Snips Platform installation"); });
                    })];
            });
        }); };
        this.packagesVersion = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("dpkg -l | grep snips | awk '{printf(\"%- 30s %- 10s\\n\", $2,$3)}'")];
            });
        }); };
        this.updateWifi = function (name, passphrase) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("(echo ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev;             echo update_config=1;             echo ;             wpa_passphrase \"" + name + "\" \"" + passphrase + "\")             | sudo tee /etc/wpa_supplicant/wpa_supplicant.conf > /dev/null")
                        .then(function (success) {
                        return _this.ssh.exec('sudo wpa_cli reconfigure');
                    })];
            });
        }); };
        this.statusWifi = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('sudo wpa_cli status')
                        .then(function (response) {
                        var ssid;
                        var status;
                        response.split('\n')
                            .map(function (line) { return line.split('='); })
                            .forEach(function (lineComponents) {
                            var key = lineComponents[0];
                            var value = lineComponents[1];
                            if (key === 'ssid') {
                                ssid = value;
                            }
                            else if (key === 'wpa_state') {
                                status = value;
                            }
                        });
                        return [ssid, status];
                    })];
            });
        }); };
        this.reconnectWifi = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('sudo wpa_cli reconnect')];
            });
        }); };
        this.disconnectWifi = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('sudo wpa_cli disconnect')];
            });
        }); };
        this.sshCommandLog = function (command, listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.execCommand(command, {
                        onStdout: function (chunk) {
                            listener(chunk.toString('utf8'));
                        },
                        onStderr: function (chunk) {
                            listener(chunk.toString('utf8'));
                        },
                    })];
            });
        }); };
        this.sshCopyId = function (hostname, username) { return __awaiter(_this, void 0, void 0, function () {
            var sshPubKeyFile, command;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(fsExtra.existsSync(snipsRSAKeyFilePath) === false)) return [3, 2];
                        return [4, this.sshKeygen()];
                    case 1:
                        sshPubKeyFile = _a.sent();
                        this.add_snips_rsa_key_to_ssh_config_if_needed();
                        return [3, 3];
                    case 2:
                        sshPubKeyFile = fsExtra.readFileSync(snipsRSAKeyFilePath + '.pub', 'utf8');
                        this.add_snips_rsa_key_to_ssh_config_if_needed();
                        _a.label = 3;
                    case 3:
                        command = "echo \"" + sshPubKeyFile + "\" | exec sh -c 'cd ; umask 077 ; mkdir -p .ssh && cat >> .ssh/authorized_keys || exit 1 ; if type restorecon >/dev/null 2>&1 ; then restorecon -F .ssh .ssh/authorized_keys ; fi'";
                        return [2, this.ssh.exec(command)];
                }
            });
        }); };
        this.sshKeygen = function () { return __awaiter(_this, void 0, void 0, function () {
            var command;
            return __generator(this, function (_a) {
                command = this.ssh_keygen_binPath() + " -t rsa -b 2048 -C \"Snips RSA key\" -N \"\" -f " + snipsRSAKeyFilePath;
                shelljs.exec(command, { async: false, silent: false });
                try {
                    return [2, fsExtra.readFileSync(snipsRSAKeyFilePath + '.pub', 'utf8')];
                }
                catch (e) {
                    throw new Error("Snips RSA Key couldn't be found");
                }
                return [2];
            });
        }); };
        this.ssh = new nodeSsh();
    }
    SSHService.prototype.ssh_keygen_binPath = function () {
        if (process.platform !== 'win32') {
            return 'ssh-keygen';
        }
        switch (process.arch) {
            case 'ia32': return path.join(__dirname, '..', 'bin', 'ssh-keygen-32.exe');
            case 'x64': return path.join(__dirname, '..', 'bin', 'ssh-keygen-64.exe');
        }
        throw new Error('Unsupported platform');
    };
    SSHService.prototype.add_snips_rsa_key_to_ssh_config_if_needed = function () {
        var sshConfigPath = os.homedir() + '/.ssh/config';
        var identityFilePath = '  IdentityFile ~/.ssh/' + snipsRSAKeyName;
        var sshConfigFile;
        try {
            var sshConfigFileLines = fsExtra.readFileSync(sshConfigPath, 'utf8').split('\n');
            if (sshConfigFileLines.indexOf(identityFilePath) >= 0) {
                return;
            }
            var hostStarIndex = sshConfigFileLines.indexOf('Host *');
            if (hostStarIndex >= 0) {
                sshConfigFileLines.splice(hostStarIndex + 1, 0, identityFilePath);
            }
            else {
                sshConfigFileLines.push('Host *');
                sshConfigFileLines.push(identityFilePath);
            }
            sshConfigFile = sshConfigFileLines.join('\n');
        }
        catch (e) {
            sshConfigFile = "Host *\n  UseKeychain yes\n  AddKeysToAgent yes\n" + identityFilePath;
        }
        fsExtra.writeFileSync(sshConfigPath, sshConfigFile);
    };
    SSHService.fetchBootHostname = function (ips) { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.all(ips.map(function (ip) { return __awaiter(_this, void 0, void 0, function () {
                        var _this = this;
                        var newConnection, hostnames;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    newConnection = new nodeSsh();
                                    return [4, newConnection.connect({
                                            host: ip,
                                            username: 'pi',
                                            password: 'raspberry',
                                        })
                                            .then(function (success) { return __awaiter(_this, void 0, void 0, function () {
                                            var snipsHostname, hostname;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4, newConnection.exec('cat /boot/hostname').catch(function (e) { return ''; })];
                                                    case 1:
                                                        snipsHostname = _a.sent();
                                                        return [4, newConnection.exec('cat /etc/hostname').catch(function (e) { return ''; })];
                                                    case 2:
                                                        hostname = _a.sent();
                                                        if (snipsHostname.includes('No such file or directory')) {
                                                            snipsHostname = '';
                                                        }
                                                        return [2, { hostname: hostname, snipsHostname: snipsHostname }];
                                                }
                                            });
                                        }); })
                                            .catch(function (failure) {
                                            return { snipsHostname: '', hostname: '' };
                                        })];
                                case 1:
                                    hostnames = _a.sent();
                                    return [2, { ip: ip, hostname: hostnames.hostname, snipsHostname: hostnames.snipsHostname }];
                            }
                        });
                    }); }))];
                case 1: return [2, _a.sent()];
            }
        });
    }); };
    return SSHService;
}());
exports.SSHService = SSHService;
